import clr

import sys

from System.Windows.Browser import HtmlPage
from System.Windows import Application

import wpf
       
class DebugStream(object):
    _console = None
    _visible = False
    _show = False
       
    def write(self, data):
        if wpf.Dispatcher.CheckAccess():
            if not DebugStream._visible:
                self._display_show()
            c = self.Console            
            txt = c.GetProperty('value')
            c.SetProperty('value', txt + data)
        else:
            wpf.Dispatcher.BeginInvoke(lambda: self.write(data))
                
    def _get_console(self):
        ''' Must be called from Browser UI Thread. '''
        if DebugStream._console is None:
            # Yes, this is a possible race condition, but the worst 
            # that will happen is it gets set more than once
            DebugStream._console = HtmlPage.Document.GetElementById('debugTxt')
            
        return DebugStream._console
    
    def _display_show(self):
        ''' Must be called from Browser UI Thread. '''
        if not DebugStream._show:
            show = HtmlPage.Document.GetElementById('debugConsoleShow')
            show.SetStyleAttribute('display', 'block')
            self._show = True
            
    def _hide_show(self):
        ''' Must be called from Browser UI Thread. '''
        if DebugStream._show:
            show = HtmlPage.Document.GetElementById('debugConsoleShow')
            show.SetStyleAttribute('display', 'none')
            self._show = False
    
    def _set_visible(self, value):
        if wpf.Dispatcher.CheckAccess():
            if value and not DebugStream._visible:
                self._hide_show()
                console = HtmlPage.Document.GetElementById('debugConsole')
                console.SetStyleAttribute('display', 'block')
            elif not value and self._visible:
                console = HtmlPage.Document.GetElementById('debugConsole')
                console.SetStyleAttribute('display', 'none')
                self._display_show()
                
            DebugStream._visible = value
        else:
            wpf.Dispatcher.BeginInvoke(lambda: self._set_visible(value))
        
    Console = property(_get_console)
    Visible = property(lambda s: DebugStream._visible, _set_visible)
       
def excepthook(sender, e):
    if not wpf.Dispatcher.CheckAccess():
        sys.stderr.Visible = True
        sys.stderr.write(Application.Current.Environment.GetEngine('py').FormatException(e.ExceptionObject))
       
def startup():
    sys.stdout = sys.stderr = DebugStream()
    
    Application.Current.UnhandledException += excepthook
    
    bug()
    
def bug():
    obj = Py()
    print obj.blocks

class Tag(object):
    __slots__ = () 
    
class Py(Tag):
    __slots__ = ('blocks')
    
    def __init__(self):
        self.blocks = [] # stack
    
startup()
